/* 
 * Formation ENVOL 2014 - Atelier électronique embarquée 2
 * Station météo 2.0
 * Matériel : idem + Mémoire 2.0 (DS1307)
 */

    /* RELEVÉ DONNÉES MÉTÉO */
    
// Inclusion de la librairie nécessaire pour la lecture du DHT11
#include <DHT.h>

//Déclaration de la pin reliée au capteur
#define DHTPIN 2

// Déclaration du type de capteur utilisé et initialisation
#define DHTTYPE DHT11
DHT dht(DHTPIN, DHTTYPE);

    /* DATALOGGING */

// Inclusion des librairies nécessaires à l'utilisation du shield Mémoire
// (les deux premières sont intégrées à l'IDE Arduino)
#include <SD.h>
#include <Wire.h>
#include <RTClib.h>

// Déclaration de l'objet "horloge"
RTC_DS1307 RTC;

void setup()
{
  Serial.begin(9600); // Initialisation liaison série
  dht.begin();        // Initialisation DHT11
  
  // Initialisation carte SD
  pinMode(10, OUTPUT);
  if (!SD.begin(10))
  {
    Serial.println("Card failed !");
    return;
  }
  Serial.println("SD Card initialized.");
  
  // Initialisation RTC
  Wire.begin();
  RTC.begin();
  
  // Mise à l'heure suivant paramètres système
  RTC.adjust(DateTime(__DATE__, __TIME__));
  if (!RTC.isrunning())
  {
    Serial.println("RTC is NOT running !");
  }
  Serial.println("DS1307 set.");
}

void loop()
{
  // Relevé des valeurs en provenance du DHT11
  float hum = dht.readHumidity();
  float temp = dht.readTemperature();
  
  // Relevé des valeurs en provenance de la photorésistance et conversion en pourcentage
  int lum = analogRead(0);
  lum = map(lum, 150, 1000, 0, 100); // Valeurs à rajuster si besoin
  
  // Timestamp
  DateTime now = RTC.now();

  // Impression sur moniteur série
  Serial.print(now.year(), DEC);
  Serial.print('/');
  Serial.print(now.month(), DEC);
  Serial.print('/');
  Serial.print(now.day(), DEC);
  Serial.print(' ');
  Serial.print(now.hour(), DEC);
  Serial.print(':');
  Serial.print(now.minute(), DEC);
  Serial.print(':');
  if (timestamp.second() < 10)
  {
    Serial.print('0');
  }
  Serial.print(now.second(), DEC);
  Serial.print(" - ");
  
  Serial.print("Humidite : ");
  Serial.print(hum);
  Serial.print(" %\t");
  Serial.print("Temperature : ");
  Serial.print(temp);
  Serial.print(" *C\t");
  Serial.print("Luminosite : ");
  Serial.print(lum);
  Serial.println(" %");
  
  // Impression dans fichier texte sur carte SD
  File fichier = SD.open("meteo.txt", FILE_WRITE);
  
  fichier.print(now.year(), DEC);
  fichier.print('/');
  fichier.print(now.month(), DEC);
  fichier.print('/');
  fichier.print(now.day(), DEC);
  fichier.print(' ');
  fichier.print(now.hour(), DEC);
  fichier.print(':');
  fichier.print(now.minute(), DEC);
  fichier.print(':');
  if (timestamp.second() < 10)
  {
    fichier.print('0');
  }
  fichier.print(now.second(), DEC);
  fichier.print(" - ");
  
  fichier.print("Humidite : ");
  fichier.print(hum);
  fichier.print(" %\t");
  fichier.print("Temperature : ");
  fichier.print(temp);
  fichier.print(" *C\t");
  fichier.print("Luminosite : ");
  fichier.print(lum);
  fichier.println(" %");
  fichier.close();
  
  // Délai entre deux mesures 
  delay(2000);
}
